#   Copyright Graham Jones 2014

#   This code is released under the Creative Commons 
#   Attribution-NonCommercial 4.0 International (CC BY-NC 4.0)
#   licence, found here:
#   http://creativecommons.org/licenses/by-nc/4.0/


##################################################
# PARAMETERS
# STACEY 

smcTreeID <- function() { "smcTree" }
taxonSetOfSetsID <- function() { "taxonSetOfSets" }
# spp/min-cluster and sequences IDs not done here

bdcModelID <- function() { "BirthDeathCollapseModel" }
bdcGrowthID <- function() { "bdcGrowthRate.smcTree" }
bdcRelDeathID <- function() { "bdcRelativeDeathRate.smcTree" }
bdcCollapseWtID <- function() { "bdcCollapseWeight.smcTree" }
bdcOriginHtID <- function() { "bdcOriginHeight.smcTree" }
bdcCollapseHtID <- function() { "collapseHeight" }

popSFID <- function() { "popPriorScale" }

smcCoalescentID <- function() { "smcCoalescent" }
InvGammaComponentID <- function(c) { paste0("InvGammaComponent.", c) }



######################################################

alignmentID <- function(g) { paste0("gene.", g) } 

# GENE TREES

geneTreeID <- function(g) { paste0("geneTree.", g) }
geneTreeCoalFactorID <- function(g) { paste0("gTreeCF.", g) }
geneTaxonSetID <- function(g) { paste0("geneTaxonSet.", g) }
clockRateID <- function(g) { paste0("clockRate.", g) }
kappaID <- function(g) { paste0("kappa.", g) }
frequenciesID <- function(g) { paste0("frequencies.", g) }

geneTreeLhoodID <- function(g) { paste0("genetreeLhood.", g) }


######################################################
# OPERATORS
# STACEY

nodesNudgeID <- function() { "nodesNudge" }
coordinatedPruneRegraftID <- function() { "CoordinatedPruneRegraft" }
focusedScalerID <- function() { "FocusedNodeHeightScaler" }
popSFScalerID <- function() { "popSFScaler" }
bdcGrowthScalerID <- function() { "bdcGrowthScaler" }
bdcReldeathScalerID <- function() { "bdcReldeathScaler" }
bdcCollapseWtScalerID <- function() { "bdcCollapseWtScaler" }
bdcOriginHtScalerID <- function() { "bdcOriginHtScaler" }


# STANDARD: for smcTree
nodeReheightID <- function() { "nodeReheight" }

# STANDARD: for gene trees
clockRateScalerID <- function(g) { paste0("clockRateScaler.", g) }
treeScalerID <- function(g) { paste0("treeScaler.", g) }
treeRootScalerID <- function(g) { paste0("treeRootScaler.", g) }
upClock.downHeightsID <- function(g) { paste0("upClock.downHeights.", g) }

subtreeSlideID <- function(g) { paste0("subtreeSlide.", g) }
treeScalerID <- function(g) { paste0("treeScaler.", g) }
wideID <- function(g) { paste0("wide.", g) }
narrowID <- function(g) { paste0("narrow.", g) }
WilsonBaldingID <- function(g) { paste0("WilsonBalding.", g) }
uniformID <- function(g) { paste0("uniform.", g) }

kappaScalerID <- function(g) { paste0("kappaScaler.", g) }
frequenciesExchangerID <- function(g) { paste0("frequenciesExchanger.", g) }


# STANDARD: for smcTree and gene trees
upGrowthClocks.downPopsHeightsID  <- function() { "upGrowthClocks.downPopsHeights" }








