library(coda)
library(MASS)


#fpathbase <- "C:/Users/Work/AAA/Programming/ProgramOutput/STACEY/Q/Qg1t10/Q4LOGg1t10r1s42"
# YEg4
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 96.2   197.0   258.1   254.1   306.6   432.1 

# YEg14
# summary(ESSs)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 93.31  180.30  234.20  241.80  293.00  456.60 




# YHg14
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 104.8   177.3   224.8   230.4   264.8   380.3


read.log <- function(fpathbase, rep) {
  x <- read.table(paste0(fpathbase, rep, ".txt"), header=TRUE)
  burnin <- 1001
  xb <- x[burnin:nrow(x),]
  xx <- as.mcmc(xb)
  xx
  }



find.ESSs.posterior <- function(fpathbase) {
  Nreps <- 50
  ESSs <- rep(0, Nreps)
  for (r in 1:Nreps) {
    xx <- read.log(fpathbase, r)
    x <- xx[,"posterior"]
    ESSs[r] <- effectiveSize(x)
  }
  cat(fpathbase, "\n")
  print(summary(ESSs))
  cat("\n\n")
  
}


find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/YEg4/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/ZEg4/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/YHg4/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/ZHg4/4LOGr")

find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/YEg8/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/ZEg8/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/YHg8/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/ZHg8/4LOGr")

find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/YEg14/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/ZEg14/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/YHg14/4LOGr")
find.ESSs.posterior("C:/Users/Work/AAA/Programming/ProgramOutput/Olave-STACEY/ZHg14/4LOGr")


