library(ape)

# This need a NEXUS file with end; at the end, so won't work while BEAST is running
# or interrupted

collapseheight <- 0.00001 

ops <- "BR"

dpath <- "C:/Users/Work/AAA/Programming/ProgramOutput/STACEY/P/Pg1t10/"

fname.gtree <- "P4GTSg1t10r1s42"
fname.stree <- "P4STSg1t10r1s42"
fname.out <- "P4SGSg1t10r1s42-stree-gtrees-"



plot.tree <- function(tree, n, g) {
  roothgt <- max( branching.times(tree) )
  
  ntips <- length(tree$tip.label)
  
  x <- roothgt/20
  #ss <- c(.0001,0.0002,.0005,.001,.002,.005,.01,.02,.05,.1,.2,.5)
  ssss <- c(1,2,5)
  ss <- c(.0000001*ssss, .000001*ssss, .00001*ssss, .0001*ssss, .001*ssss, .01*ssss, .1*ssss, 1*ssss)
  s <- ss[1]
  for (i in 1:length(ss)) {
    if (x > ss[i]) { s <- ss[i] }
  }
  if (g >= 0) {
    plot(tree, label.offset = 0.01*roothgt, cex=.7, main=paste0("Sample ", n, " gene ", g))
  } else {
    plot(tree, label.offset = 0.01*roothgt, cex=.7, main=paste0("Sample ", n, " species"))
  }
  for (i in c(1:50)) {
    lines(x=rep(roothgt-i*s,2), y=c(1,ntips), col="#0000ff44")
  }
  for (i in c(5,10,15,20,25,30,35,40,45)) {
    lines(x=rep(roothgt-i*s,2), y=c(1,ntips), col="#0000ffcc")
    mtext(at=roothgt-i*s, line=0, i*s, cex=0.7)
  }
  lines(x=rep(roothgt-collapseheight,2), y=c(1,ntips), col="#ff000088")
} 




plot.trees <- function(genes, n) {
  pdffpath <- paste0(dpath, fname.out, ops, n, ".pdf")
  pdf(file=pdffpath,width=6,height=9)
  
  par(mfcol=c(2,1))
  
  fpath <- paste0(dpath, fname.stree, ops, ".txt")
  trees <- read.nexus(file=fpath)
  plot.tree(trees[[n]], n, -1)
  
  for (g in genes) {
    fpath <- paste0(dpath, fname.gtree, ops, "-", g, ".txt")
    trees <- read.nexus(file=fpath)
    plot.tree(trees[[n]], n, g)
  }
  
  dev.off()
}



plot.trees(c(1:1), 200)
plot.trees(c(1:1), 300)
plot.trees(c(1:1), 400)
plot.trees(c(1:1), 500)
plot.trees(c(1:1), 600)
plot.trees(c(1:1), 700)
plot.trees(c(1:1), 800)
plot.trees(c(1:1), 900)



