
make.beast2xml.loggers <- function(sim.options) {
  #DBUGTUNE.Operator.fpath <- substr(DBUGTUNE.fpath, 1, nchar(DBUGTUNE.fpath)-4)
  #DBUGTUNE.Operator.fpath <- paste0(DBUGTUNE.Operator.fpath, "_Operators.txt")
  make.beast2xml.main.logger(sim.options)
  make.beast2xml.smctree.logger(sim.options)
  for (g in 1:sim.options$nofgenes) {
    make.beast2xml.gtree.logger(sim.options, g)
  }
  make.beast2xml.screen.logger(sim.options)
  make.beast2xml.DEBUG.logger(sim.options)
  
}


make.beast2xml.main.logger <- function(sim.options) {
  nofgenes <- sim.options$nofgenes
  catln(1, "<logger",
        id("tracelog"),
        namevalue("fileName", sim.options$sampledparams.fpath),
        namevalue("logEvery", sim.options$beastparams.logevery),
        namevalue("model", "@posterior"),
        namevalue("sort", "smart"), ">")
  
  catln(2, idref("log", "posterior", NULL))
  catln(2, idref("log", "likelihood", NULL))
  catln(2, idref("log", "prior", NULL))
  catln(2, idref("log", smcCoalescentID(), NULL))
  catln(2, idref("log", popSFID(), NULL))
  commentln("birth-death-collapse model (?)")
  catln(2, idref("log", bdcModelID(), NULL))
  commentln("birth-death-collapse parameters")
  catln(2, idref("parameter", bdcGrowthID(), "log"))
  catln(2, idref("parameter", bdcRelDeathID(), "log"))
  catln(2, idref("parameter", bdcCollapseWtID(), "log"))
  commentln("smcTree origin height")
  catln(2, idref("parameter", bdcOriginHtID(), "log"))
  commentln("Statistic for number of clusters")
  catln(2, "<log",
        spec("stacey.BirthDeathCollapseNClustersStatistic"),
        namevalue("bdcm", IDtoREF(bdcModelID())),
        namevalue("smcTree", IDtoREF(smcTreeID())), "/>")
  commentln("Statistic for population size")
  catln(2, "<log",
        spec("stacey.PopSampleStatistic"),
        namevalue("popPriorScale", IDtoREF(popSFID())),
        namevalue("piomsCoalDist", IDtoREF(smcCoalescentID())), "/>")
  
  #   <log id="TreeHeight.Species" spec="beast.evolution.tree.TreeHeightLogger" tree="@Tree.t:Species"/>
  for (g in 1:nofgenes) {
    commentln(paste0("tracelog parameters for gene tree ", g))
    catln(2, idref("log", geneTreeLhoodID(g), NULL))
    #   <log idref="treePrior.t:29"/> ??
    #   <log id="TreeHeight.t:29" spec="beast.evolution.tree.TreeHeightLogger" tree="@Tree.t:29"/>
    catln(2, idref("parameter", clockRateID(g), "log"))
    catln(2, idref("parameter", kappaID(g), "log"))
    catln(2, idref("parameter", frequenciesID(g), "log"))
  }
  catln(1, "</logger>")
}


make.beast2xml.smctree.logger <- function(sim.options) {
  #sampledspptrees.fpath
  catln(1, "<logger",
        id("smcTreeLogger"),
        namevalue("fileName", sim.options$sampledspptrees.fpath),
        namevalue("logEvery", sim.options$beastspptree.logevery),
        namevalue("mode", "tree"), ">")
  catln(2, "<log", 
        id("TreeWithMetaDataLogger.smc"),
        spec("beast.evolution.tree.TreeWithMetaDataLogger"),
        namevalue("tree", IDtoREF(smcTreeID())), "/>")
  catln(1, "</logger>")
  
# TODO: do I need this? My smcTree is a plain tree, no demographics
#   <log id="SpeciesTreeLoggerX" 
#   popSize="@popSize" 
#   popSizeTop="@popSizeTop" 
#   spec="beast.evolution.speciation.SpeciesTreeLogger" 
#   speciesTreePrior="@SpeciesTreePopSize.Species"
#   tree="@Tree.t:Species"> 
#   <treetop id="treeTopFinder" spec="beast.evolution.speciation.TreeTopFinder">
#   <tree idref="Tree.t:29"/>
#   <tree idref="Tree.t:26"/>
#   </treetop>
#   </log>

  

}

make.beast2xml.gtree.logger <- function(sim.options, g) {
  catln(1, "<logger",
        id(paste0("geneTreeLogger.", g)),
        namevalue("fileName", paste0(sim.options$sampledgtrees.fpathbase, g, ".txt")),
        namevalue("logEvery", sim.options$beastgtrees.logevery),
        namevalue("mode", "tree"), ">")
  catln(2, "<log", 
        id(paste0("TreeWithMetaDataLogger.", g)),
        spec("beast.evolution.tree.TreeWithMetaDataLogger"),
        namevalue("tree", IDtoREF(geneTreeID(g))), "/>")
  catln(1, "</logger>")
}



make.beast2xml.screen.logger <- function(sim.options) {
  catln(1, "<logger",
        id("screenlog"),
        namevalue("logEvery", sim.options$beastscreen.logevery),
        namevalue("model", "@posterior"), ">")
  catln(2, idref("log", "posterior", NULL))
  catln(2, "<log",
        id("ESS.posterior"),
        spec("util.ESS"),
        namevalue("arg", "@posterior"), "/>")
  catln(2, idref("log", "likelihood", NULL))
  catln(2, idref("log", "prior", NULL))
  catln(2, idref("log", smcCoalescentID(), NULL))
  
  catln(2, "<log",
        spec("stacey.BirthDeathCollapseNClustersStatistic"),
        namevalue("bdcm", IDtoREF(bdcModelID())),
        namevalue("smcTree", IDtoREF(smcTreeID())), "/>")
  
  catln(1, "</logger>")
  
}


make.beast2xml.DEBUG.logger <- function(sim.options) {
  #DBUGTUNE.fpath
}






