#                             STACEY

# Started 2014-11-23. 
# This is for testing multispecies coalescent algorithm STACEY on prior only



library(ape)
library(phangorn)

################################################################################
###################### Setting up file paths, loading code #####################

cat("STACEY ('GNT' version) started\n")
#Args <- commandArgs(TRUE)
Args <- c("C:/Users/Work/AAA/Programming/ProgramOutput/STACEY/Q")

stopifnot(length(Args) == 1) 

# Where this code is
setwd("C:/Users/Work/AAA/Programming/biology/STACEYSimulations")


# input config is here. All output goes in subdirectories of this
CONFIG.DIR <- Args[1]

# BEAST2 jar
BEAST2.jar.fpath <- "C:\\Users\\Work\\AAA\\biology\\SoftWare\\BEAST.v2.1.3\\lib\\beast.jar"

# TreeAnnotator jar
TreeAnnotator.jar.fpath <- "xxxxxxxxxxx"

# Species Delimitation Analyser jar
SpeciesDA.jar.fpath <- "xxxxxxxxxx"


# Should just be able to do "java" but doesn't work on my system
# when .BAT file calls R calls java
java.fpath <- "\"C:\\Program Files\\Java\\jre7\\bin\\java.exe\""

 
# Code providing functions
source("STACEY_0randomseeds.r")
source("STACEY_1readconfig-pparams.r")
source("STACEY_1readconfig-GNT.r")
source("STACEY_2makespptree.r")
source("STACEY_3makegtrees.r")
source("STACEY_4makeseqfiles.r")
source("STACEY_5beast2xml_toplevel.r")
source("STACEY_5GNT.r")
source("STACEY_6beast2xml_utils.r")
source("STACEY_6beast2xml_ids.r")
source("STACEY_6beast2xml_data.r")
source("STACEY_6beast2xml_distribution.r")
source("STACEY_6beast2xml_init.r")
source("STACEY_6beast2xml_state.r")
source("STACEY_6beast2xml_operators.r")
source("STACEY_6beast2xml_loggers.r")
source("STACEY_7simmatrix.r")


cat("STACEY simulation running with directory", CONFIG.DIR, "\n")

CONFIG <- read.config()

cat("Config has beeen read\n")

make.BEAST2.XMLs(doing.olave=FALSE, prior.only=TRUE)

#run.BEAST2.allreps(java.fpath, BEAST.jar.fpath)

#run.TreeAnn.allreps(java.fpath, TreeAnn.jar.fpath)

#run.SppDA.make.simmatrix.allreps(java.fpath, SppDA.jar.fpath)






